/*
 * EG_LCD.c
 *
 * Created: 2/9/2014 10:49:54 PM
 * Author: GANESH SELVARAJ
 */ 




#include<avr/io.h>
#include<util/delay.h>
#include<inttypes.h>

#include "lcd.h"



void LCD_write_string(const char *str)	//store address value of the string in pointer *str
{
	int i=0;
	while(str[i]!='\0')				// loop will go on till the NULL character in the string
	{
		if (str[i]=='*')
		{
			i++;
			int8_t cc=str[i]-'0';
			if(cc>=0 && cc<=7)
			{
				dis_data(cc);
			}
			else
			{
				dis_data('%');
				dis_data(str[i]);
			}
		}
		else dis_data(str[i]);				// sending data on LCD byte by byte
		
		
		i++;
	}
	return;
}







void lcd_init()	// function for initialize
{
	DDRB=0xFF;
	dis_cmd(0x02);		// to initialize LCD in 4-bit mode.
	dis_cmd(0x28);		//to initialize LCD in 2 lines, 5X7 dots and 4bit mode.
	dis_cmd(0x0C);
	dis_cmd(0x06);
	dis_cmd(0x0E);
	custom_char();

	gotoxy(0,0);
}

void dis_cmd(char cmd_value)
{
	char cmd_value1;
	
	cmd_value1 = ((cmd_value>>4) & 0x0F);	//shift 4-bit and mask
	lcdcmd(cmd_value1);			// send to LCD
	
	cmd_value1 = cmd_value & 0x0F;		//mask lower nibble because PA4-PA7 pins are used.
	lcdcmd(cmd_value1);			// send to LCD
}


void dis_data(char data_value)
{
	char data_value1;
	
	data_value1=((data_value>>4)&0x0F);
	
	lcddata(data_value1);
	
	data_value1=data_value&0x0F;
	lcddata(data_value1);
}

void lcdcmd(char cmdout)
{
	PORTB=cmdout;
	PORTB&=~(1<<rs);
	PORTB&=~(1<<rw);
	PORTB|=(1<<en);
	_delay_ms(1);
	PORTB&=~(1<<en);
}

void lcddata(char dataout)
{
	PORTB=dataout;
	PORTB|=(1<<rs);
	PORTB&=~(1<<rw);
	PORTB|=(1<<en);
	_delay_ms(1);
	PORTB&=~(1<<en);
}
void clrscr()
{
	_delay_ms(10);
	dis_cmd(0x01);
	_delay_ms(100);
}
void gotoxy(char a,char b)
{
	
	if(a==0)  a=0b10000000;
	else if(a==1) a=0b11000000;
	else if(a==2) a=0b10010100;
	else if(a==3) a=0b11010100;
	
	
	dis_cmd(a+b); 
}

void custom_char()
{
	unsigned char c[]={0x0E, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, //FULL BAT
		0x0E, 0x1F, 0x11, 0x11, 0x1F, 0x1F, 0x1F, 0x1F, //HALF BAT
		0x0E, 0x1F, 0x11, 0x11, 0x11, 0x11, 0x1F, 0x1F, //LOW BATT
		0x0A, 0x0A, 0x0A, 0x1F, 0x1F, 0x0E, 0x04, 0x04, //AC SUPPLY
		0x11, 0x0A, 0x04, 0x0A, 0x11, 0x00, 0x00, 0x00, //X MARK
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, //Char5
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, //Char6
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, //Char7


	};
	uint8_t a[]={72,80,88,96,104,112,120,64};
	uint8_t i,j;
	for(i=0;i<sizeof(a);i++)
	{
		dis_cmd(a[i]);
		for(j=0;j<sizeof(c);j++)
		{
			dis_data(c[j]);
		}
	}
}
void lcd_write_int(int val,unsigned int field_length)
{


	char str[5]={0,0,0,0,0};
	uint8_t i=4,j=0;
	while(val)
	{
		str[i]=val%10;
		val=val/10;
		i--;
	}
	if(field_length==-1)
	while(str[j]==0) j++;
	else
	j=5-field_length;

	if(val<0) dis_data('-');
	for(i=j;i<5;i++)
	{
		dis_data(48+str[i]);
	}
}




