/*
 * VARIABLE.c
 *
 * Created: 12/07/2014 3:53:39 PM
 * Author: GANESH SELVARAJ
 */ 




#define F_CPU 16000000UL


#include <avr/io.h>
#include <util/delay.h>
#include <avr/wdt.h>
#include "lcd.h"



void SetADC()
{
	ADMUX|=(1<<REFS0);
	ADCSRA=(1<<ADEN)|(7<<ADPS0);
}

uint16_t ReadADC(uint8_t ch)
{
	//Select ADC Channel ch must be 0-7
	ch=ch&0b00000111;
	
	ADMUX&=0b11100000;
	ADMUX|=ch;
	
	//Start Single conversion
	ADCSRA|=(1<<ADSC);

	//Wait for conversion to complete
	while(!(ADCSRA & (1<<ADIF)));

	//Clear ADIF by writing one to it
	ADCSRA|=(1<<ADIF);

	return(ADC);
}
void Waiting(int j) // simple delay function
{
	uint8_t i;
	for(i=0;i<j;i++)
	_delay_ms(200);
}

int main(void)
{
		
		DDRD=0x0F;

		int v,bat;
		_delay_ms(50);		// delay of 50 milliseconds
		SetADC();
		lcd_init();
		clrscr();
		LCD_write_string("UPS Status: ");
		dis_data('?');
		dis_data('?');
		dis_data('?');
		dis_data('?');
		Waiting(2);
		gotoxy(1,0);
		LCD_write_string("Adj. Vol.=");
		


     while(1)
    {
		
		if(ReadADC(2)<=300) // MAINS UNAVAILABLE
		{
			PORTD|=(1<<PD1); //BATTERY MODE ON
			PORTD&=~(1<<PD0); //CHARGE INDICATOR ON
			bat=ReadADC(1);
			
			gotoxy(0,12);
			if(bat>=850) // BATTERY LEVEL MORE THAN 50%
			{
				dis_data(0);
				dis_data('+');
			}
			else if((bat<850) && (bat>800)) // BATTERY LEVEL LESS THAN 50%
			{
				 dis_data(1);
				 dis_data('+');
			}
			else if ((bat<800) && (bat>=750)) // BATTERY LEVEL LESS THAN 10%
			{
				dis_data(2);
				dis_data(4);
			}
			else if (bat<750) // BATTERY AT 0%
			{
				clrscr();
				LCD_write_string("  LOW BATTERY!  ");
				Waiting(7);
				clrscr();
				Waiting(1);
				LCD_write_string("  AUTOMATIC   ");
				gotoxy(1,0);
				LCD_write_string("SHUTDOWN IN: ");
				gotoxy(1,15);
				dis_data('s');
				int i=10;
				while(i>=0)
				{
					gotoxy(1,13);
					lcd_write_int(i,2);
					gotoxy(1,16);
					Waiting(5);
					i--;
				}
				PORTD=0; //DISCONNECTING BATTERY SUPPLY TO DEVELOPMENT BOARD AND DC PSU BLOCK
				wdt_enable(7);
				Waiting(25);
				wdt_reset();
				wdt_disable();
				
			}
			
			dis_data(3);
			dis_data(4);
		}
		else if(ReadADC(2)>300) //MAINS AVAILABLE
		{
			PORTD=0; //SET TO MAINS MODE
			PORTD|=(1<<PD0); //SET CHARGING MODE
		
			
			gotoxy(0,12);
			dis_data(0);
			dis_data('?');
			dis_data(3);
			dis_data('+');
		}
		
		gotoxy(1,10);
		v=((ReadADC(0)/1024.00)*3000.00);
		lcd_write_int((v/100),2);
		dis_data('.');
		lcd_write_int((v%100),2);
		dis_data('V');

		Waiting(2);
				
    }
}